From d3dd350586f74852dcda61137c5c10df8eb477ab Mon Sep 17 00:00:00 2001
From: Chao Long <longchao@uniontech.com>
Date: Wed, 9 Sep 2020 14:04:39 +0800
Subject: [PATCH v3] ntdll: Fix arch heap free.

Signed-off-by: Chao Long <longchao@uniontech.com>
---
 dlls/ntdll/actctx.c | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

diff --git a/dlls/ntdll/actctx.c b/dlls/ntdll/actctx.c
index 625cffcca8..7e18544cda 100644
--- a/dlls/ntdll/actctx.c
+++ b/dlls/ntdll/actctx.c
@@ -2265,7 +2265,11 @@ static void parse_dependent_assembly_elem( xmlbuf_t *xmlbuf, struct actctx_loade
         {
             parse_assembly_identity_elem(xmlbuf, acl->actctx, &ai, &elem);
             /* store the newly found identity for later loading */
-            if (ai.arch && !wcscmp(ai.arch, wildcardW)) ai.arch = strdupW( current_archW );
+            if (ai.arch && !wcscmp(ai.arch, wildcardW))
+            {
+                RtlFreeHeap( GetProcessHeap(), 0, ai.arch );
+                ai.arch = strdupW( current_archW );
+            }
             TRACE( "adding name=%s version=%s arch=%s\n",
                    debugstr_w(ai.name), debugstr_version(&ai.version), debugstr_w(ai.arch) );
             if (!add_dependent_assembly_id(acl, &ai)) set_error( xmlbuf );
-- 
2.20.1

